/*  This file is part of the program:

    nV@derz! (nvaderz)
    Copyright (C) 2006-2013  Eric Pellegrin

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

    Eric Pellegrin can be reached by email at pellea72(at)yahoo(dot)com
    (Note: email address modified to evade unsolicited email search bots.
        Change (at) to @ and (dot) to . to read name@company.com )
*/

#include "getfilesettings.h"

int applysettings(char *name, char *value)
{
    if(!(strcmp(name, "player_x_speed")))
    {
	if(value)
	    player_x_speed = strtod(value, NULL);
    }
    else if(!(strcmp(name, "horde_x_speed")))
    {
	if(value)
	    horde_x_speed = strtod(value, NULL);
    }
    else if(!(strcmp(name, "laser_y_speed")))
    {
	if(value)
	    laser_y_speed = strtod(value, NULL);
    }
    else if(!(strcmp(name, "bomb_y_speed")))
    {
	if(value)
	    bomb_y_speed = strtod(value, NULL);
    }
    else if(!(strcmp(name, "horde_start_y")))
    {
	if(value)
	    horde_start_y = strtod(value, NULL);
    }
    else if(!(strcmp(name, "player_height")))
    {
	if(value)
	    player_height = strtod(value, NULL);
    }
    else if(!(strcmp(name, "player_width")))
    {
	if(value)
	    player_width = strtod(value, NULL);
    }
    else if(!(strcmp(name, "player_space_top")))
    {
	if(value)
	    player_space_top = strtod(value, NULL);
    }
    else if(!(strcmp(name, "screen_baseline")))
    {
	if(value)
	    screen_baseline = strtod(value, NULL);
    }
    else if(!(strcmp(name, "invader_height")))
    {
	if(value)
	    invader_height = strtod(value, NULL);
    }
    else if(!(strcmp(name, "invader_width")))
    {
	if(value)
	    invader_width = strtod(value, NULL);
    }
    else if(!(strcmp(name, "invader_space_vertical")))
    {
	if(value)
	    invader_space_vertical = strtod(value, NULL);
    }
    else if(!(strcmp(name, "invader_space_horizontal")))
    {
	if(value)
	    invader_space_horizontal = strtod(value, NULL);
    }
    else if(!(strcmp(name, "laser_height")))
    {
	if(value)
	    laser_height = strtod(value, NULL);
    }
    else if(!(strcmp(name, "laser_width")))
    {
	if(value)
	    laser_width = strtod(value, NULL);
    }
    else if(!(strcmp(name, "bomb_height")))
    {
	if(value)
	    bomb_height = strtod(value, NULL);
    }
    else if(!(strcmp(name, "bomb_width")))
    {
	if(value)
	    bomb_width = strtod(value, NULL);
    }
    else if(!(strcmp(name, "left_boundary")))
    {
	if(value)
	    left_boundary = strtod(value, NULL);
    }
    else if(!(strcmp(name, "right_boundary")))
    {
	if(value)
	    right_boundary = strtod(value, NULL);
    }

    /* hud settings */
    else if(!(strcmp(name, "score_digit_width")))
    {
        if(value)
            score_digit_width = strtod(value, NULL);
    }
    else if(!(strcmp(name, "score_digit_height")))
    {
        if(value)
            score_digit_height = strtod(value, NULL);
    }
    else if(!(strcmp(name, "score_digit_hspace")))
    {
        if(value)
            score_digit_hspace = strtod(value, NULL);
    }
    else if(!(strcmp(name, "score_left_limit")))
    {
        if(value)
            score_left_limit = strtod(value, NULL);
    }
    else if(!(strcmp(name, "score_right_limit")))
    {
        if(value)
            score_right_limit = strtod(value, NULL);
    }
    else if(!(strcmp(name, "score_topline")))
    {
        if(value)
            score_topline = strtod(value, NULL);
    }
    else if(!(strcmp(name, "num_score_digits")))
    {
        if(value)
            num_score_digits = strtod(value, NULL);
    }
    else if(!(strcmp(name, "lives_unit_width")))
    {
        if(value)
	    lives_unit_width = strtod(value, NULL);
    }
	else if(!(strcmp(name, "lives_unit_height")))
	{
		if(value)
			lives_unit_height = strtod(value, NULL);
	}
	else if(!(strcmp(name, "lives_unit_hspace")))
	{
		if(value)
			lives_unit_hspace = strtod(value, NULL);
	}
	else if(!(strcmp(name, "lives_left_limit")))
	{
		if(value)
			lives_left_limit = strtod(value, NULL);
	}
	else if(!(strcmp(name, "lives_right_limit")))
	{
		if(value)
			lives_right_limit = strtod(value, NULL);
	}
	else if(!(strcmp(name, "lives_topline")))
	{
		if(value)
			lives_topline = strtod(value, NULL);
	}
	else if(!(strcmp(name, "num_lives_units")))
	{
		if(value)
			num_lives_units = strtod(value, NULL);
	}
	else if(!(strcmp(name, "lives_ship1_x")))
	{
		if(value)
			lives_ship1_x = strtod(value, NULL);
	}
	else if(!(strcmp(name, "lives_ship2_x")))
	{
		if(value)
			lives_ship2_x = strtod(value, NULL);
	}
	else if(!(strcmp(name, "lives_ship_y")))
	{
		if(value)
			lives_ship_y = strtod(value, NULL);
	}
	else if(!(strcmp(name, "lives_ship_width")))
	{
		if(value)
			lives_ship_width = strtod(value, NULL);
	}
	else if(!(strcmp(name, "lives_ship_height")))
	{
		if(value)
			lives_ship_height = strtod(value, NULL);
	}

	else if(!(strcmp(name, "double_invader_start_level")))
	{
		if(value)
			double_invader_start_level = strtod(value,NULL);
	}
	else if(!(strcmp(name, "triple_invader_start_level")))
	{
		if(value)
			triple_invader_start_level = strtod(value,NULL);
	}
	else if(!(strcmp(name, "double_invader_odds")))
	{
		if(value)
			double_invader_odds = strtod(value, NULL);
	}
	else if(!(strcmp(name, "triple_invader_odds")))
	{
		if(value)
			triple_invader_odds = strtod(value, NULL);
	}
	else if(!(strcmp(name, "double_invader_odds_change")))
	{
		if(value)
			double_invader_odds_change=strtod(value,NULL);
	}
	else if(!(strcmp(name, "triple_invader_odds_change")))
	{
		if(value)
			triple_invader_odds_change=strtod(value,NULL);
	}
	else if(!(strcmp(name, "player_bounds_offsetx1")))
	{
		if(value)
			player_bounds_offsetx1=strtod(value,NULL);
	}
	else if(!(strcmp(name, "player_bounds_offsetx2")))
	{
		if(value)
			player_bounds_offsetx2=strtod(value,NULL);
	}
	else if(!(strcmp(name, "player_bounds_offsety1")))
	{
		if(value)
			player_bounds_offsety1=strtod(value,NULL);
	}
	else if(!(strcmp(name, "player_bounds_offsety2")))
	{
		if(value)
			player_bounds_offsety2=strtod(value,NULL);
	}

    return 0;
}
